Index: Fl_JPEG_Image.cxx
===================================================================
RCS file: /cvsroot/fltk/fltk/src/Attic/Fl_JPEG_Image.cxx,v
retrieving revision 1.1.2.10
diff -u -r1.1.2.10 Fl_JPEG_Image.cxx
--- Fl_JPEG_Image.cxx	11 Apr 2004 04:38:57 -0000	1.1.2.10
+++ Fl_JPEG_Image.cxx	16 Dec 2004 21:37:38 -0000
@@ -85,11 +85,14 @@
 
   cinfo.err = jpeg_std_error(&jerr);
   jerr.error_exit = jpeg_error_handler;
+  jerr.output_message = jpeg_error_handler;
 
   jpeg_create_decompress(&cinfo);
   jpeg_stdio_src(&cinfo, fp);
   jpeg_read_header(&cinfo, 1);
 
+  if (cinfo.err->msg_code) goto error_return;
+    
   cinfo.quantize_colors      = (boolean)FALSE;
   cinfo.out_color_space      = JCS_RGB;
   cinfo.out_color_components = 3;
@@ -108,6 +111,8 @@
 
   while (cinfo.output_scanline < cinfo.output_height)
   {
+    if (cinfo.err->msg_code) goto error_return;
+
     row = (JSAMPROW)(array +
                      cinfo.output_scanline * cinfo.output_width *
                      cinfo.output_components);
@@ -118,6 +123,24 @@
   jpeg_destroy_decompress(&cinfo);
 
   fclose(fp);
+
+  // JPEG error handling...
+  error_return:
+
+  if (array) jpeg_finish_decompress(&cinfo);
+  jpeg_destroy_decompress(&cinfo);
+
+  fclose(fp);
+
+  if (array) {
+    w(0);
+    h(0);
+    d(0);
+
+    delete[] array;
+    array = 0;
+    alloc_array = 0;
+  }
 #endif // HAVE_LIBJPEG
 }
 
